#include <Arduino.h>
#include <SPI.h>
#include "Adafruit_BLE.h"
#include "Adafruit_BluefruitLE_SPI.h"
#include "Adafruit_BluefruitLE_UART.h"
#include "RTClib.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define BUFSIZE                        128   // Size of the read buffer for incoming data
#define VERBOSE_MODE                   true  // If set to 'true' enables debug output

// SHARED SPI SETTINGS
// ----------------------------------------------------------------------------------------------
// The following macros declare the pins to use for HW and SW SPI communication.
// SCK, MISO and MOSI should be connected to the HW SPI pins on the Uno when
// using HW SPI.  This should be used with nRF51822 based Bluefruit LE modules
// that use SPI (Bluefruit LE SPI Friend).
// ----------------------------------------------------------------------------------------------
#define BLUEFRUIT_SPI_CS               8
#define BLUEFRUIT_SPI_IRQ              7
#define BLUEFRUIT_SPI_RST              4    // Optional but recommended, set to -1 if unused

// SOFTWARE SPI SETTINGS
// ----------------------------------------------------------------------------------------------
// The following macros declare the pins to use for SW SPI communication.
// This should be used with nRF51822 based Bluefruit LE modules that use SPI
// (Bluefruit LE SPI Friend).
// ----------------------------------------------------------------------------------------------
#define BLUEFRUIT_SPI_SCK              13
#define BLUEFRUIT_SPI_MISO             12
#define BLUEFRUIT_SPI_MOSI             11

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#if SOFTWARE_SERIAL_AVAILABLE
  #include <SoftwareSerial.h>
#endif

  #define FACTORYRESET_ENABLE         1
  #define MINIMUM_FIRMWARE_VERSION    "0.6.6"
  #define MODE_LED_BEHAVIOUR          "MODE"


RTC_DS3231 rtc;
//String mystr = "Hello!"; //String data
int sig = 0;
char question[1000];
char answer[6];
int index = 0;
uint8_t set_hour = 160;
uint8_t set_min = 160;
bool flag = false;
uint8_t button_count = 5;
bool answer_flag = false;
uint8_t a_i = 0;
uint8_t num_question = 0;
uint8_t false_answer = 0;
uint8_t question_time = 0;
bool temp_flag = false;
int time_count = 0;
uint8_t b_count = 0;
bool send_flag = false;
DateTime now;

 
const int c = 261;
const int d = 294;
const int e = 329;
const int f = 349;
const int g = 391;
const int gS = 415;
const int a = 440;
const int aS = 455;
const int b = 466;
const int cH = 523;
const int cSH = 554;
const int dH = 587;
const int dSH = 622;
const int eH = 659;
const int fH = 698;
const int fSH = 740;
const int gH = 784;
const int gSH = 830;
const int aH = 880;
 
const int buzzerPin = 9;
const int ledPin1 = 12;
const int ledPin2 = 13;
const int buttonPinA = A0;
const int buttonPinB = A1;
const int buttonPinC = A2;
const int buttonPinD = A3;
int temppp = 0;
 
int counter = 0;


/* ...hardware SPI, using SCK/MOSI/MISO hardware SPI pins and then user selected CS/IRQ/RST */
Adafruit_BluefruitLE_SPI ble(BLUEFRUIT_SPI_CS, BLUEFRUIT_SPI_IRQ, BLUEFRUIT_SPI_RST);


// A small helper
void error(const __FlashStringHelper*err) {
  Serial.println(err);
  while (1);
}


void send_data(char store[], int size_idx){
  index = 0;
  //Serial.println("in send data");
  for (int i = 0; i <= size_idx; i++){
     Serial.write(store[i]);
  }
}

void get_alarm(){
  set_hour = 0;
  set_min = 0;
  
  char c = (char)ble.read();
  
  while (c != ':'){
    set_hour = set_hour*10 + (c - '0');
    c = (char)ble.read();
    }
  c = (char)ble.read();
  while (c != '?'){
    set_min = set_min*10 + (c -'0');
    c = (char)ble.read();
    }
}

void beep(int note, int duration)
{
  //Play tone on buzzerPin
  tone(buzzerPin, note, duration);
 
  //Play different LED depending on value of 'counter'
  if(counter % 2 == 0)
  {
    digitalWrite(ledPin1, HIGH);
    delay(duration);
    digitalWrite(ledPin1, LOW);
  }else
  {
    digitalWrite(ledPin2, HIGH);
    delay(duration);
    digitalWrite(ledPin2, LOW);
  }
 
  //Stop tone on buzzerPin
  noTone(buzzerPin);
 
  delay(50);
 
  //Increment counter
  counter++;
}
 
void firstSection()
{
  beep(a, 500);
  beep(a, 500);    
  beep(a, 500);
  beep(f, 350);
  beep(cH, 150);  
  beep(a, 500);
  beep(f, 350);
  beep(cH, 150);
  beep(a, 650);
 
  delay(500);
 
  beep(eH, 500);
  beep(eH, 500);
  beep(eH, 500);  
  beep(fH, 350);
  beep(cH, 150);
  beep(gS, 500);
  beep(f, 350);
  beep(cH, 150);
  beep(a, 650);
 
  delay(500);
}
 
void secondSection()
{
  beep(aH, 500);
  beep(a, 300);
  beep(a, 150);
  beep(aH, 500);
  beep(gSH, 325);
  beep(gH, 175);
  beep(fSH, 125);
  beep(fH, 125);    
  beep(fSH, 250);
 
  delay(325);
 
  beep(aS, 250);
  beep(dSH, 500);
  beep(dH, 325);  
  beep(cSH, 175);  
  beep(cH, 125);  
  beep(b, 125);  
  beep(cH, 250);  
 
  delay(350);
}

void speaker(){
    //Play first section
  firstSection();
 
  //Play second section
  secondSection();
 
  //Variant 1
  beep(f, 250);  
  beep(gS, 500);  
  beep(f, 350);  
  beep(a, 125);
  beep(cH, 500);
  beep(a, 375);  
  beep(cH, 125);
  beep(eH, 650);
 
  delay(100);
}

char check_button() {
  while(1) {
    if (b_count % 20 == 0) {
      beep(a, 500);
      b_count = 0;
    }
      if (analogRead(buttonPinA) >900) {
        while(analogRead(buttonPinA) >900) {
        }
        Serial.write('#');
        return 'A';
      }
      else if (analogRead(buttonPinB) > 900) {
        while(analogRead(buttonPinB) > 900) {
        }
        Serial.write('#');
        return 'B';
      }
      else if (analogRead(buttonPinC) > 900) {
        while(analogRead(buttonPinC) > 900) {
        }
        Serial.write('#');
        return 'C';
      }
      else if (analogRead(buttonPinD) > 900) {
        while(analogRead(buttonPinD) > 900) {
        }
        Serial.write('#');
        return 'D';
      }
      b_count++;
  }
}
  
void setup() {
  Serial.begin(1200);

  ble.begin(VERBOSE_MODE);

  /* Disable command echo from Bluefruit */
  ble.echo(false);
  ble.verbose(false);  // debug info is a little annoying after this point!

  /* Wait for connection */
  ble.isConnected();
  ble.isVersionAtLeast(MINIMUM_FIRMWARE_VERSION);
  ble.setMode(BLUEFRUIT_MODE_DATA);

//  rtc.begin();
   if (! rtc.begin()) {
    Serial.println("Couldn't find RTC");
    while (1);
  }

  if (rtc.lostPower()) {
    Serial.println("RTC lost power, lets set the time!");
    // following line sets the RTC to the date & time this sketch was compiled
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
    // This line sets the RTC with an explicit date & time, for example to set
    // January 21, 2014 at 3am you would call:
    //rtc.adjust(DateTime(2019, 11, 3, 3, 0, 0));
  }
  

  pinMode(buzzerPin, OUTPUT);
  digitalWrite(buzzerPin, LOW);
  pinMode(buttonPinA, INPUT);
  pinMode(buttonPinB, INPUT);
  pinMode(buttonPinC, INPUT);
  pinMode(buttonPinD, INPUT);
}

void loop() {
  /*RTC-------------------------------------------------------------------------------------------------------------*/
  if (time_count % 1000 == 0) {
     now = rtc.now();
     time_count = 0;
     if (now.hour() == set_hour && now.minute() != set_min && flag == true){
      flag = false;
    }
  }
  time_count++;
  if (now.hour() == set_hour && now.minute() == set_min && flag == false) {
    flag = true;
    Serial.write('^');
      beep(a, 500);
      char button_arr[5];
      bool repeat = false;
      bool first_time = true;
      DateTime now = rtc.now();
      uint8_t start_hour = now.hour();
      uint8_t start_min = now.minute();
      uint8_t start_sec = now.second();
      while (1) {
        repeat = false;
        for (int i = 0; i < 5; i++) {
          beep(a, 500);
          button_arr[i] = check_button();
          if (button_arr[i] != answer[i]) {
            if (first_time == true) {
              false_answer++;
            }
            repeat = true;
          }
        }
        first_time = false;
        if (repeat == false) {
          break;
        }
      }
      Serial.write('@');
      now = rtc.now();
      uint8_t end_hour = now.hour();
      uint8_t end_min = now.minute();
      uint8_t end_sec = now.second();
      question_time = (end_hour - start_hour) *3600 + (end_min - start_min)*60 + (end_sec - start_sec);
      send_flag = true;
  }

  
  
  /*Bluetooth----------------------------------------------------------------------------------------------------*/
//beep(a, 500);
while ( ble.available() )
  {
    char c = (char)ble.read();
    
    if (c == '/' && send_flag == true) {
      ble.print(question_time);
      ble.print(" ");
      ble.print(false_answer);
      false_answer = 0;
      send_flag = false;
      break;
    }
    if (c == '!'){
        get_alarm();
        break;
      }                                                                                                                                                                                                                                                                                                                                             
    if (c == '$'){
      num_question = 0;
    }
    if (c == '%'){
      answer_flag = true;
      question[index] = c;
      continue;
    }
    if (c == '#'){
      answer_flag = false;
      a_i = 0;
 
      send_data(question, index);
      index = 0;
      break;
    }
    if (c == '@'){
      num_question++;
      if (num_question == 1) {
        continue;
      }
    }

    if (answer_flag == true){
      answer[a_i] = c;
      a_i++;
    }
    else {
      question[index] = c;
      index++;
    }
  }

}

bool getUserInput(char buffer[], uint8_t maxSize)
{
  // timeout in 100 milliseconds
  TimeoutTimer timeout(100);

  memset(buffer, 0, maxSize);
  while( (!Serial.available()) && !timeout.expired() ) { delay(1); }

  if ( timeout.expired() ) return false;

  delay(2);
  uint8_t count=0;
  do
  {
    count += Serial.readBytes(buffer+count, maxSize);
    delay(2);
  } while( (count < maxSize) && (Serial.available()) );

  return true;
}
